define([
    "dojo/_base/declare",
    "dojo/_base/lang",
// Parent class and mixins
    "./_ActivityViewModel",
// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.activities.activity.message"
],
function(
    declare,
    lang,
// Parent class and mixins
    _ActivityViewModel,
// Resources
    localization
) {

    return declare([_ActivityViewModel], {
        // summary:
        //      The view model for an activity.
        // tags:
        //      internal

        // hasMessage: [public] Boolean
        //      Indicates whether this activity has a message. Used to
        //      determine the edit label.
        hasMessage: false,

        // comments: [public] Array
        //      Array of comments on activity
        comments: null,

        _editLabelGetter: function() {
            // summary:
            //      Gets the edit label.
            // tags:
            //      private

            return this.hasMessage ? localization.reply.label : localization.comment.label;
        },

        _save: function (message) {
            // summary:
            //      Adds a new comment.
            // tags:
            //      protected
            var promise =  this.activityService.addComment(this.id, message);
            promise.then(lang.hitch(this, function (comment) {
                this.comments.push(comment);
                this.set("comments", this.comments);
            }));
            return promise;
        }
    });
});
